require 'ImgPL'
require 'test/unit'

class TestImgPL < Test::Unit::TestCase
  $p = ImgPL.new
  # $p.logger.level = Logger::WARN

  def test_math
    assert_equal(5, $p.run("10/2"))
    assert_equal(8, $p.run("(10/2)+3"))
    assert_equal(20, $p.run("100/(2+3)"))
    assert_equal(100, $p.run("((10*2)/2)*10"))
    assert_equal(4, $p.run("2**2"))
    assert_equal(3125, $p.run("(10/2)**(15/3)"))
    assert_equal(-10, $p.run("5-15"))

    assert_not_equal(5, $p.run("30-23"))
  end
  
  def test_math_w_variables
    assert_equal(nil, $p.run("var=5"))
    assert_equal(5, $p.run("var"))
    assert_equal(nil, $p.run("var = var + 5"))
    assert_equal(nil, $p.run("test = 2"))
    assert_equal(4, $p.run("test**test"))
    assert_equal(nil, $p.run("t = (var**test)"))
    assert_equal(100, $p.run("var**test"))
  end
 
  def test_strings
    assert_equal(nil, $p.run("hello = \"Hello\""))
    assert_equal("Hello World", $p.run("\"Hello\"+\" World\""))
    assert_equal("Hello World", $p.run("hello + \" World\""))
  end

  def test_arrays
    assert_equal([1,2,3], $p.run("[1,2,3]"))
    assert_equal(nil, $p.run("a = [1,2,3]"))
    assert_equal([1,3], $p.run("a - 2"))
    assert_equal(3, $p.run("a[1]"))
  end
end
